题目描述
给定一个整数数组 nums 和一个目标值 target,请你在该数组中找出和为目标值的那两个整数,并返回他们的数组下标。
你可以假设每种输入只会对应一个答案。但是,数组中同一个元素不能使用两遍。
示例:
给定 nums = [2, 7, 11, 15], target = 9
因为 nums[0] + nums[1] = 2 + 7 = 9
所以返回 [0, 1]
解法1:暴力法
遍历整个数组,寻找是否存在 target - x 。因为 x 以前的数都已经匹配过了,直接从 x + 1 寻找即可。所以解法如下:
class Solution {
public int[] twoSum(int[] nums, int target) {
int numsLength = nums.length;
int[] result = new int[2];
for(int i = 0; i < numsLength; i++) {
for(int j = i + 1; j < numsLength; j++) {
if(nums[i] + nums[j] == target) {
result[0] = i;
result[1] = j;
return result;
}
}
}
return result;
}
}
解法2:hash 表法
暴力法的时间复杂度是O(n^2),空间复杂度是O(1)。相对来说时间效率比较低,同样是为了寻找到目标值:target - x 的位置,可以采用 hash 表来存储数组值和数组下标。因此在寻找 target - 1 时,只需要O(1)的时间复杂度即可以找到。(ps:参考自官方题解思路)
class Solution {
public int[] twoSum(int[] nums, int target) {
Map<Integer, Integer> hashmap = new HashMap<>();
for(int i = 0; i < nums.length; i++) {
if(hashmap.containsKey(target - nums[i])) {
return new int[]{hashmap.get(target - nums[i]), i};
}
hashmap.put(nums[i], i);
}
return new int[0];
}
}
网友评论